
bind PotMeter <Any-Enter> {
	focus -force %W
}

set color gold

proc addPotMeter { frame name format } {
	global color

	frame $frame -bg $color

	set size 48

	if { $format == "small" } {
		set size 32
	}
	if { $format == "medium" } {
		set size 44
	}
	if { $format == "large" } {
		set size 60
	}

	potmeter $frame.pot -variable $name -start 128 -bg $color -style amp \
		-size $size -command "setLeslie $name" -shadow 7 -fg gold \
		-pothighcolor white -potpointcolor black -potmaincolor red
	label $frame.label -text $name -relief flat -width 10 -bg $color
	pack $frame.pot -side top
	pack $frame.label -side top -expand y -fill y

	pack $frame -side left -expand y -fill y
}

proc buildPanel { frame } {
	addPotMeter $frame.speed speed medium
	addPotMeter $frame.direct direct medium
	addPotMeter $frame.delay delay medium
	addPotMeter $frame.decay reverb medium
	addPotMeter $frame.resonance resonance medium
	addPotMeter $frame.overdrive overdrive medium
}

proc buildLeslie {} {
	global color

	button .base -width 750 -height 150 -bg black -fg black
	bindtags .base {SLabLogo 2 3 4}

	frame .base.controls -relief raised -bd 3 -bg $color
	frame .base.controls.t -bg $color
	label .base.controls.t.text -relief flat -fg black -bg $color -justify left\
		-text "      Leslie" -font "-*-lucida-*-r-*-sans-*-300-*-*-*-*-*-*"
	frame .base.controls.c -bg $color

	buildPanel .base.controls.c

	pack .base.controls.t.text -side left -anchor w
	pack .base.controls.t -side top -expand y -fill x -anchor w
	pack .base.controls.c -side top -anchor w -padx 40 -expand y -fill both
	pack .base.controls -side top -anchor w -padx 40 -expand y -fill both
	pack .base -ipadx 60 -expand y -fill both

	wm title . "Leslie Rotary Speaker"
}

proc buildMemories {} {
	global memoryFileName

	#
	# Want to get some values from a config file, if possible.
	#
	set memoryFileName [setLeslie getfilename].Leslie

	menu .base.controls.mem
	.base.controls.mem add cascade -menu .base.controls.mem.load -label "Load"
	.base.controls.mem add cascade -menu .base.controls.mem.save -label "Save"
	menu .base.controls.mem.load
	.base.controls.mem.load add command -label "Memory 0" -command \
		"setLeslie memget $memoryFileName 0"
	.base.controls.mem.load add command -label "Memory 1" -command \
		"setLeslie memget $memoryFileName 1"
	.base.controls.mem.load add command -label "Memory 2" -command \
		"setLeslie memget $memoryFileName 2"
	.base.controls.mem.load add command -label "Memory 3" -command \
		"setLeslie memget $memoryFileName 3"
	menu .base.controls.mem.save
	.base.controls.mem.save add command -label "Memory 0" -command \
		"setLeslie memset $memoryFileName 0"
	.base.controls.mem.save add command -label "Memory 1" -command \
		"setLeslie memset $memoryFileName 1"
	.base.controls.mem.save add command -label "Memory 2" -command \
		"setLeslie memset $memoryFileName 2"
	.base.controls.mem.save add command -label "Memory 3" -command \
		"setLeslie memset $memoryFileName 3"

	bind .base.controls <Button-3> {
		catch {tk_popup .base.controls.mem %X %Y}
	}

	#
	# Load the first file is possible
	#
	catch {setLeslie memget $memoryFileName 0}
}

buildLeslie
buildMemories

